<?php
/*
 * Plugin Name: BP Mag Addons Pack
 * Description: a set of widgets for BP mag, includes siteInfo widget,featured posts widget and recent news widget :)
 * Version: 1.1
 * Author: Brajesh Singh
 * Contributor: Anu Sharma
 */

class BPMag_SiteInfo_Widget extends WP_Widget{

    function __construct() {
         parent::__construct(false, $name = __( '(BP Mag) Site Info Widget', 'bpmag' ));

    }

	function widget($args, $instance) {
		extract( $args );

		 echo $before_widget;
		echo $before_title
			. $instance['title']
			. $after_title;
			$page_id=$instance["page_id"];

			if(empty($page_id))
				$page_id=2;//it take by default page that take page id 2 
			$post=get_post($page_id);

                       echo  get_the_post_thumbnail( $page_id, 'post-thumbnail');
                       echo "<div>";
                        if(empty($instance['maxchars']))
                            echo force_balance_tags($post->post_content);
			else
                            echo force_balance_tags(substr($post->post_content,0,$instance['maxchars']));
                        echo "</div>";
                        echo "<span class=\"readmore alignright\"> <a href='".get_permalink($post->ID)."'>".__("Read more...","bpmag")."</a></span><br class='clear' />";
		 echo $after_widget;
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['maxchars'] = absint($new_instance['maxchars'] ) ;//how many galleries
		$instance['page_id'] = $new_instance['page_id']  ;//how many galleries

		return $instance;
	}

	function form( $instance ) {
		$instance = wp_parse_args( (array) $instance, array( 'title' => __('SiteInfo Widget','bpmag'), 'maxchars' => 300,'page_id'=>2 ) );
		$title = strip_tags( $instance['title'] );
		$maxchars = absint( $instance['maxchars'] );
		$page_id= $instance['page_id'];
        ?>
        <p>
            <label for="bpmag-widget-siteinfo-title"><?php _e('Title:', 'bpmag'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr(stripslashes($title)); ?>" /></label>
        </p>
        <p>
            <label for="bpmag-widget-siteinfo-maxchar"><?php _e('maximum letters to show(0 for no limit)', 'bpmag'); ?>
                <input type="text" id="<?php echo $this->get_field_id('maxchars'); ?>" name="<?php echo $this->get_field_name('maxchars'); ?>" class="widefat" value="<?php echo esc_attr(absint($maxchars)); ?>" />
            </label>
        </p>
        <p>
            <label for="bpmag-widget-page-id"><?php _e('Select a page', 'bpmag'); ?>
                <?php $name = $this->get_field_name('page_id'); ?>
                <?php wp_dropdown_pages("name=" . $name . "&show_option_none=" . __('- Select -') . "&selected=" . $page_id); ?>
            </label>
        </p>

	<?php
	}

}//end of class


/**
 * Register BpMag Feaured Posts widget
 */


class BPMag_Featured_Posts_Widget extends WP_Widget{


    function __construct() {
        parent::__construct(false, $name = __( '(BP Mag) Feaured Posts', 'bpmag' ));
      
    }

    
function widget($args,$instance) {
    extract( $args );
    $max=$instance["max"];
	$max_chars=$instance["max_chars"];
	
    echo $before_widget;
    echo $before_title
	. $instance['title']
	. $after_title;

     $cat_id=$instance["cat_id"];

	if(empty($cat_id))
            $cat_id=1;//default to about page

        $featured_posts=new Wp_Query();
        $featured_posts->query("showposts=".$max."&max=".$max."&cat=".$cat_id);

        while($featured_posts->have_posts()):$featured_posts->the_post();?>
        <div class="post">
            <div class="post-content">
                    <?php if (has_post_thumbnail($featured_posts->post->ID) && !empty($max_chars)): ?>
                        <a href="<?php the_permalink(); ?>" rel="permalink to <?php the_title(); ?>" ><img src="<?php echo bpmag_get_thumb_mid($featured_posts->post->ID); ?>" alt="slideshow" class="attachment-post-thumbnail"/></a>
                    <?php endif; ?>
                    <h2><?php the_title(); ?></h2>
                    <div class="entry">

                        <?php
                        if (empty($max_chars))
                            the_content("more");
                        else
                            echo bpmag_get_post_excerpt($featured_posts->post, $max_chars);
                        ?>
                    </div>
                    <span class="slide-comment alignleft"><?php comments_popup_link(__('Be the first to leave a comment.', 'bpmag'), __('1 Comment &#187;', 'bpmag'), __('% Comments &#187;', 'bpmag')); ?></span>
                    <span class="slide-readmore alignright"><a href="<?php the_permalink(); ?>"><?php _e("Read more...", "bpmag"); ?></a></span>
                    <div class="clear"> </div>
              </div>
        </div>
	<?php endwhile;
                                      
        	 echo $after_widget;
}

    // now update
    
 function update($new_instance,$old_instance){

     $instance=$old_instance;
     $instance["max"]=$new_instance["max"];
     $instance["max_chars"]=$new_instance["max_chars"];
     $instance["cat_id"]=$new_instance["cat_id"];
     $instance["title"]=$new_instance["title"];
     return $instance;
 }
    //form
function form( $instance ) {
	$instance = wp_parse_args( (array) $instance, array( 'title' => __('Featured Posts Widget','bpmag'), "cat_id"=>1,"max"=>1,"max_chars"=>0 ) );
	$title = strip_tags( $instance['title'] );
	$max = absint( $instance['max'] );
	$max_chars = absint( $instance['max_chars'] );
	$cat_id= $instance['cat_id'];

        ?>
        <p>
            <label for="featured-posts-widget-title"><?php _e('Title:', 'bpmag'); ?>
                <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr(stripslashes($title)); ?>" />
            </label>
        </p>
        
        <p>
            <label for="featured-posts-widget-max"><?php _e('Maximum No. of Posts', 'bpmag'); ?>
                <input type="text" id="<?php echo $this->get_field_id('max'); ?>" name="<?php echo $this->get_field_name('max'); ?>" class="widefat" value="<?php echo esc_attr(absint($max)); ?>" style="width:30%;"/>
            </label>
        </p>
        
        <p>
            <label for="featured-posts-widget-max-chars"><?php _e('Maximum No. of Words(0, for all the content)', 'bpmag'); ?>
                <input type="text" id="<?php echo $this->get_field_id('max_chars'); ?>" name="<?php echo $this->get_field_name('max_chars'); ?>" class="widefat" value="<?php echo esc_attr(absint($max_chars)); ?>" style="width:30%;"/>
            </label>
        </p>
        
        <p>
            <label for="featured-posts-widget-id"><?php _e('Select a Category', 'bpmag'); ?>
                <?php $name = $this->get_field_name('cat_id'); ?>
                <?php wp_dropdown_categories("name=" . $name . "&show_option_none=" . __('- Select -') . "&selected=" . $cat_id); ?>

            </label>
        </p>

	<?php
	}

} //end of featured posts widget

/**
 * Register BpMag Recent News Widget
 */

class BPMag_Recent_News_Widget extends WP_Widget {
//3 column news widget

//how many column

 //select categories for each of the col
function __construct() {
    parent::__construct(false, $name = __( '(BP Mag) Recent News Widget', 'bpmag' ));
   
}
function widget($args,$instance){
    extract($args);
    
     echo $before_widget;
	 echo $before_title
		. $instance['title']
		. $after_title;

         for($i=1;$i<=$instance["col"];$i++)
          BpMag_Recent_News_Widget::show_news_box($instance["cat_id_".$i],$instance["num_links"]);
      echo $after_widget;
}
function update($new_instance,$old_instance){

$instance=$old_instance;
$instance["num_links"]=intval($new_instance["num_links"]);
$instance["col"]=intval($new_instance["col"]);
$instance["title"]=$new_instance["title"];
for($i=1;$i<=$instance["col"];$i++)
    $instance["cat_id_".$i]=$new_instance["cat_id_".$i];
    
return $instance;
    
}
function form($instance){
    $instance=wp_parse_args((array)$instance,array("title"=>"Recent News","col"=>3,"num_links"=>3));
    $title=strip_tags($instance["title"]);
    $col=intval($instance["col"]);
    $num_links=intval($instance["num_links"]);?>

        <p>
           <label for="featured-posts-widget-title"><?php _e('Title:', 'bpmag'); ?>
                <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( stripslashes( $title ) ); ?>" />
            </label>
        </p>
        <p>
           <label for="featured-posts-widget-link-count"><?php _e( 'Maximum No. of releated links below the box' , 'bpmag'); ?>
                <input type="text" id="<?php echo $this->get_field_id( 'num_links' ); ?>" name="<?php echo $this->get_field_name( 'num_links' ); ?>" class="widefat" value="<?php echo esc_attr( absint( $num_links ) ); ?>" />
            </label>
	</p>
	<p>
            <label for="featured-posts-widget-max"><?php _e( 'Maximum No. of News Boxes' , 'bpmag'); ?>
                <input type="text" id="<?php echo $this->get_field_id( 'col' ); ?>" name="<?php echo $this->get_field_name( 'col' ); ?>" class="widefat" value="<?php echo esc_attr( absint( $col ) ); ?>" />
            </label>
	</p>
        
    <?php

       for($i=1;$i<=$col;$i++){//show the form
             ?>
            <p>
               
            <label for="featured-posts-widget-id"><?php _e( sprintf('Select a Category for news box %d',$i) , 'bpmag'); 
                
                
                $name=$this->get_field_name( 'cat_id_'.$i );
                
                wp_dropdown_categories('name='.$name."&show_option_none=".__('- Select -').'&selected=' . $instance['cat_id_'.$i]);
                ?>

            </label>
               
        </p>
<?php
   }
   
//for showing the form code
}

//Featured story widget

//recent news widgets
//helper function
function show_news_box($cat_id,$num_links){
    $news=new WP_Query();
  
    $news->query("cat=".$cat_id."&showposts=1&max=1");

    while($news->have_posts()):$news->the_post();?>
        <div class="news">  <!-- news1 goes here... -->
            <h3 class="news-cat-title"><?php echo get_cat_name($cat_id);  ?></h3>
            <div class="news-box">
                <?php if(bpmag_post_has_image($news->post->ID)):?>
                <a href="<?php the_permalink();?>" rel="permalink to <?php the_title_attribute();?>" class="news-thumb"><img src="<?php echo bpmag_get_thumb_small($news->post->ID);?>" alt="<?php the_title();?>" /></a>
                <?php endif;?>
		<div class="b-newsdate_box"> <?php the_time("F j Y");?></div>
                <div class="news-excerpt">
                    <?php the_excerpt();?>
                    <span class="readmore alignright"> 
                            <a href="<?php the_permalink();?>">
                                    <?php _e("Read more...","bpmag");?>
                            </a>
                    </span>
                    <div class="clear"> </div>
                    <div class="more-news-links">
                        <ul>
                         <?php  bpmag_list_recent_posts("cat=".$cat_id."&max=".$num_links."&exclude=".$news->post->ID."&before=<li>&after=</li>");?>
                        </ul>
                    </div>
                   </div>
                        </div>
                     </div>
    <?php endwhile;
    
}

}//end of recent news class
//register widgets
function bpmag_addons_register_widget() {
	add_action('widgets_init', create_function('', 'return register_widget("BPMag_Featured_Posts_Widget");') );
	add_action('widgets_init', create_function('', 'return register_widget("BPMag_Recent_News_Widget");') );
	add_action('widgets_init', create_function('', 'return register_widget("BPMag_SiteInfo_Widget");') );


        }
add_action( 'plugins_loaded', 'bpmag_addons_register_widget' );

function bpmag_list_recent_posts($arg){
 
    $params=wp_parse_args($arg, array("max"=>5,"before"=>'','after'=>'','show'=>true));
    extract($params,EXTR_SKIP);
	if(empty($cat)&&empty($category_name))
		return;
	//if($category_name)
		//$id=get_cat_ID($category_name);
	if($cat)
		$id=$cat;
        
	$posts=get_posts("cat=".$id."&showposts=".$max."&offset=1");//we need one more post than the actual
	//global $post;
	$html="";
	$count=1;

	foreach($posts as $post){
		setup_postdata($post);
		if($post->ID==$exclude)
				continue;
	 $html.=$before."<a href='".get_permalink($post->ID)."' title='".__("Permalink to ","bpmag"). get_the_title($post->ID)."'>".get_the_title($post->ID)."</a>".$after;
	$count++;
	 if($count-$max>0)//funny , but it requires less calculation, hehe even more funny
		break;
}
   echo $html;

}

if(!function_exists("bpmag_post_has_image")):
    function bpmag_post_has_image($post_id=null){
    if(current_theme_supports("post-thumbnails")&&has_post_thumbnail($post_id))
        return true;
    return false;
}
endif;

function bpmag_clean_content($content){

  //remove images if any
  //do short code
$content="";
    return do_shortcode($content);

}
?>
